<?php //$Id: block_marking.php,v 1.7 2006/05/13 15:12:45 mchurch Exp $

require_once($CFG->dirroot.'/blocks/marking/lib.php');

class block_marking extends block_base {
    function init () {
        $this->title = get_string('blockname', 'block_marking');
        $this->version = 2005062700;
    }

    function specialization() {
//        $this->course = get_record('course', 'id', $this->instance->pageid);
        /// For now, let's cheat and use the global.
        global $course, $SITE, $USER;
        if ($this->instance->pageid == SITEID) {
            $this->course = $SITE;
        } else {
            $this->course = $course;
        }
        $this->userid = $USER->id;
        $this->isteacher = isteacher($this->course->id, $this->userid, false);
    }

    function has_config() {
            return true;
    }

    function instance_allow_config() {
        return true;
    }

    function instance_config_save($data) {
        /// Different logic for the site then for a course.
        if ($this->instance->pageid == SITEID) {
        /// This override will make sure only the current user's data get's overwritten.
            $data = stripslashes_recursive($data);
            if (!isset($data->selcourse[$this->userid])) {
                error('Unexpected data recieved in block_marking::instance_config_save!');
            }
            $this->config->selcourse[$this->userid] = $data->selcourse[$this->userid];
            $data = $this->config;
        }
        return parent::instance_config_save($data);
    }

    function get_content() {
        global $CFG;

        $this->requested_group = optional_param('group', false);
        $this->requested_course = optional_param('id', false);

        if (!isset($this->config->targetass)) {
            $this->config->targetass = 0;
        }

        if ($this->content !== NULL) {
            return $this->content;
        }

        if ($this->isteacher || ($this->course->id == SITEID)) {
            /// Teacher display checks again for the SITE level.
            $this->teacher_display();
        } else {
            $this->student_display();
        }

        return $this->content;
    }

    function teacher_display() {
        global $CFG;

        if (!$this->can_access()) {
            $this->content = '';
            return false;
        }

    /// Setup some data needed throughout:
        $this->block_marking_belowpercent = 60;
        if (isset($CFG->block_marking_belowpercent)) {
            $this->block_marking_belowpercent = $CFG->block_marking_belowpercent;
        }

        $this->block_marking_listnum = 2;
        if (isset($CFG->block_marking_listnum)) {
            $this->block_marking_listnum = $CFG->block_marking_listnum;
        }

        $this->content = New object;
        $this->content->text = '';

        if ($this->course->id == SITEID) {
            $this->sitepage_display();
        } else {
            $this->course_display('view.php');
        }
        return true;
    }

    function student_display() {
        global $CFG;

        if ($this->course->id == SITEID) {
            $this->content = '';
            return false;
        }

        $this->title = get_string('studentblockname', 'block_marking');
        $this->content = New object;

        $grades = mb_get_grades();
        if (!isset($grades[$this->userid])) {
            $this->content->text = 'No grade info found!';
            return false;
        }

        $userstats = $grades[$this->userid]['student_data'];
        $classpos = mb_get_class_position($grades, $this->userid);
        $this->content->text = get_string('courseaverage1', 'block_marking', $userstats['percent']).'<br />';
        $a->pos = $classpos[0];
        $a->num = $classpos[1];
        $this->content->text .= get_string('courseposition1', 'block_marking', $a).'<br />';
        $this->content->text .= '<br /><a href="'.$CFG->wwwroot.'/blocks/marking/stats.php?id='.
                                $this->course->id.'&amp;tid='.$this->config->targetass.'">'.
                                get_string('fullreport', 'block_marking').'</a><br />';
    }

    function can_access() {
        return (!empty($this->course) &&
                ((($this->course->id == SITEID) && isteacherinanycourse($this->userid, false)) || 
                 (($this->course->id != SITEID) && $this->isteacher)));
    }

    function handle_config() {
        global $CFG, $PAGE, $USER;

        $hiddendata = array(
            'sesskey' => $USER->sesskey,
            'instanceid' => $this->instance->id,
            'blockaction' => 'config'
        );

        // To this data, add anything the page itself needs to display
        $hiddendata = array_merge($hiddendata, $PAGE->url_get_parameters());

        if($data = data_submitted()) {
            $remove = array_keys($hiddendata);
            foreach($remove as $item) {
                unset($data->$item);
            }
            if(!$this->instance_config_save($data)) {
                error('Error saving block configuration');
            }
            // And nothing more, continue with displaying the page
            return false;
        }
        else {
        
            // We need to show the config screen, so we highjack the display logic and then die
            $this->content->text .= '<form method="post" action="'. $PAGE->url_get_path() .'">';
            $this->content->text .= '<p>';
            foreach($hiddendata as $name => $val) {
                $this->content->text .= '<input type="hidden" name="'. $name .'" value="'. $val .'" />';
            }
            $this->content->text .= '</p>';

            ob_start();
            include($CFG->dirroot.'/blocks/'.$this->name().'/config_instance.html');
            $this->content->text .= ob_get_contents();
            ob_end_clean();
            $this->content->text .= '</form>';
            return true;
        }
    }

    function sitepage_display() {
        global $CFG;

        /// Catch the blockaction request (if we made it here), in case a non-editing, non-site teacher
        /// is trying to configure the block.
        $blockaction = optional_param('blockaction', '', PARAM_CLEAN);
        $instanceid = optional_param('instanceid', 0, PARAM_INT);
        if (($blockaction == 'config') && ($instanceid == $this->instance->id) && confirm_sesskey()) {
            if ($this->handle_config()) {
                return $this->content->text;
            }
        }

        if (!isset($this->config->selcourse[$this->userid])) {
            $this->content->text = get_string('nocoursesmonitored', 'block_marking');
        } else if (!in_array(1, $this->config->selcourse[$this->userid])){
            $this->content->text = get_string('nocoursesmonitored', 'block_marking');
        } else {
            $clist = '';
            foreach ($this->config->selcourse[$this->userid] as $courseid => $monitored) {
                if ($monitored) {
                    if (!empty($clist)) {
                        $clist .= ', ';
                    } else {
                        $clist .= '(';
                    }
                    $clist .= $courseid;
                }
            }
            $clist .= ')';
            $select = 'id IN '.$clist;
            if (!$cnames = get_records_select('course', $select)) {
                $this->content->text = get_string('nocoursesmonitored', 'block_marking');
            } else {
                foreach ($cnames as $crec) {
                    /// Double check. The user may have been removed as a teacher.
                    if (!isteacher($crec->id, $this->userid)) {
                        continue;
                    }
                    $this->content->text .= '<div align="center" style="font-weight: bold">'.$crec->shortname.
                                            '</div>';
                    $this->course_display('index.php', $crec, true);
                    $this->content->text .= '<hr />';
                }
            }
        }
        $this->content->footer = '<div align="center"><a href="'.$CFG->wwwroot.'/index.php?instanceid='.
                                 $this->instance->id.'&amp;sesskey='.sesskey().'&amp;blockaction=config">'.
                                 get_string('managecourses', 'block_marking').'</a></div>';
    }

    function course_display ($url, $course = false, $sitelevel = false) {
        global $CFG;

        if ($course !== false) {
            $scourse = $this->course;
            $this->course = $course;
            unset($this->assignment);
        }

        $this->groups = array();
        if (($this->course->groupmode != SEPARATEGROUPS) || isteacheredit($this->course->id)) {
            $this->groups = get_groups($this->course->id);
        }

        if (!empty($this->groups) && ($this->requested_group !== false) && 
            (($course === false) || ($this->requested_course == $course->id))) {
            $this->currentgroup = $this->requested_group;
        } else {
            $this->currentgroup = get_current_group($this->course->id);
        }

        if ($this->currentgroup) {
            $this->users = get_group_students($this->currentgroup);
        } else {
            $this->users = get_course_students($this->course->id);
        }

        $marking_url = $CFG->wwwroot.'/blocks/marking/marking.php?id='.$this->course->id.'&amp;group='.$this->currentgroup.'&amp;mid=';

    /// The footer depends on groups, so load it now.
        $this->content->footer = '<div align="center">'.
                                 '<br /><a href="'.$CFG->wwwroot.'/blocks/marking/marking.php?id='.$this->course->id.
                                 '&amp;group='.$this->currentgroup.'">'.get_string('footer', 'block_marking').'</a>';

        $this->content->footer .= '<br /><a href="'.$CFG->wwwroot.'/blocks/marking/stats.php?id='.
                                $this->course->id.'&amp;tid='.$this->config->targetass.
                                '&amp;group='.$this->currentgroup.'">'.
                                get_string('fullreport', 'block_marking').'</a><br /></div>';

    /// Build groups menu:
        if (!empty($this->groups)) {
            $groupsmenu[0] = get_string("allparticipants");
            foreach ($this->groups as $group) {
                $groupsmenu[$group->id] = $group->name;
            }
            $this->content->text .= get_string('groups').': ';
            $this->content->text .= popup_form($url.'?id='.$this->course->id.'&amp;group=', $groupsmenu, 
                                               'markingselectgroup'.$this->course->id, $this->currentgroup, "", "", 
                                               "", true, "self");
        }

    /// Get marking data for all valid modules:
        if (!($modules = get_records('modules', '', '', '', 'name,visible'))) {
            $this->content->text .= 'No Modules Installed';
            return $this->content;
        }

        if (isset($modules['assignment'])) {
            $this->get_assignment_data('assignment');
        }
        if (isset($modules['newassignment'])) {
            $this->get_assignment_data('newassignment');
        }
        if (isset($modules['forum'])) {
            $this->get_forum_data();
        }
        if (isset($modules['journal'])) {
            $this->get_journal_data();
        }
        if (isset($modules['lesson'])) {
            $this->get_lesson_data();
        }
        
    /// If no assignment data returned, set it to false (stops warnings).
        if (!isset($this->assignment)) {
            $this->assignment = false;
        }

        if (is_array($this->assignment)) {
            $unmarked_text = '';
            $resubmit_text = '';
            $unmarked_text_count = 0;
            $resubmit_text_count = 0;
            foreach ($this->assignment as $assignment) {
                if (($assignment->unmarked > 0) &&
                    (($this->block_marking_listnum == 0) || ($unmarked_text_count < $this->block_marking_listnum))) {
                    $unmarked_text .= '<a href="'.$marking_url.$assignment->mid.'">'.
                                      $assignment->name.'('.$assignment->unmarked.')</a><br />';
                    $unmarked_text_count++;
                }
                if (($assignment->resubmitted > 0) &&
                    (($this->block_marking_listnum == 0) || ($resubmit_text_count < $this->block_marking_listnum))) {
                    $resubmit_text .= '<a href="'.$marking_url.$assignment->mid.'">'.
                                      $assignment->name.'('.$assignment->resubmitted.')</a><br />';
                    $resubmit_text_count++;
                }
            }
            if (!$sitelevel && empty($unmarked_text)) {
                $unmarked_text .= get_string('nounmarked', 'block_marking').'<br />';
            } else if (empty($unmarked_text)) {
                $unmarked_text = false;
            } else if (($this->block_marking_listnum > 0) && ($unmarked_text_count >= $this->block_marking_listnum)) {
                $unmarked_text .= '<a href="'.$marking_url.'">more...</a>';
            }
            if (!$sitelevel && empty($resubmit_text)) {
                $resubmit_text .= get_string('noresubmitted', 'block_marking').'<br />';
            } else if (empty($resubmit_text)) {
                $resubmit_text = false;
            } else if (($this->block_marking_listnum > 0) && ($resubmit_text_count >= $this->block_marking_listnum)) {
                $resubmit_text .= '<a href="'.$marking_url.'">more...</a>';
            }
        } else if (!$sitelevel){
            $unmarked_text = get_string('nomarkingdata', 'block_marking').'<br />';
            $resubmit_text = get_string('nomarkingdata', 'block_marking').'<br />';
        } else {
            $unmarked_text = false;
            $resubmit_text = false;
        }

        if (is_array($this->users)) {
            /// Reorder the users array in decreasing overdue count.
            uasort($this->users, 'sort_overdue_users');

            $unsubmitted_text = '';
            $unsubmit_text_count = 0;
            $gradebelow_text = '';
            $grade_text_count = 0;
            $totass = count($this->assignment);

            $upercents = array();
            foreach ($this->users as $user) {
                if (isset($user->overdue) && ($user->overdue > 0) &&
                    (($this->block_marking_listnum == 0) ||
                     ($unsubmit_text_count < $this->block_marking_listnum))) {
                    $unsubmitted_text .= '<a href="'.$marking_url.'&amp;muser='.$user->id.'">'.
                                         fullname($user).' ('.$user->overdue.')</a><br />';
                    $unsubmit_text_count++;
                }

            /// Grades:
                if (isset($user->grades)) {
                    if (($user->grades < $this->block_marking_belowpercent) &&
                        (($this->block_marking_listnum == 0) || ($grade_text_count < $this->block_marking_listnum))) {
                        $upercents[$user->id] = $user->grades;
                    }
                }
            }

            if (!empty($upercents)) {
                asort($upercents);
                foreach ($upercents as $uid => $ugrade) {
                    $gradebelow_text .= fullname($this->users[$uid]).' - '.$ugrade.'%<br />';
                }
            }

            $unsubmitted_title = '<br /><b>'.get_string('unsubmitted', 'block_marking').'</b><br />';
            if (!$sitelevel && empty($unsubmitted_text)) {
                $unsubmitted_text .= get_string('nounsubmitted', 'block_marking').'<br />';
            } else if (empty($unsubmitted_text)) {
                $unsubmitted_text = false;
            } else if ($sitelevel) {
                $unsubmitted_title = '<br /><a href="'.$marking_url.'">'.$unsubmit_text_count.' '.
                                     get_string('unsubmitted', 'block_marking').' '.
                                     get_string('students').'</a><br />';
                $unsubmitted_text = '';
            } else if (($this->block_marking_listnum > 0) && ($unsubmit_text_count >= $this->block_marking_listnum)) {
                $unsubmitted_text .= '<a href="'.$marking_url.'&amp;muser='.$user->id.'">more...</a><br />';
            }
        } else if (!$sitelevel) {
            $unsubmitted_text = get_string('nounsubmitted', 'block_marking').'<br />';
        } else {
            $unsubmitted_text = false;
        }

    /// Unmarked Data:
        if ($unmarked_text !== false) {
            $this->content->text .= '<br /><b>'.get_string('unmarked', 'block_marking').'</b><br />';
            $this->content->text .= $unmarked_text;
        }

    /// Resubmitted Data:
        if ($resubmit_text !== false) {
            $this->content->text .= '<br /><b>'.get_string('resubmitted', 'block_marking').'</b><br />';
            $this->content->text .= $resubmit_text;
        }

        if ($unsubmitted_text !== false) {
            $this->content->text .= $unsubmitted_title;
            $this->content->text .= $unsubmitted_text;
        }

        if (!$sitelevel) {
            $this->content->text .= '<br /><b>'.get_string('students').' '.
                                    get_string('belowaverage', 'block_marking', $this->block_marking_belowpercent).'%</b><br />';
            $this->content->text .= $gradebelow_text;
        }
    }

    function get_assignment_data($assign_type='assignment') {
        global $CFG;
        require_once($CFG->dirroot.'/mod/'.$assign_type.'/lib.php');

        $timenow = time();

        $grade_func = $assign_type.'_grades';
        if (($assignments = get_all_instances_in_course($assign_type, $this->course)) !== false) {
            foreach ($assignments as $assignment) {

            if (!isset($assignment->assignmenttype)) {
                $assignment->assignmenttype = '';
            }

            /// If assignment is graded...
              if ($assignment->grade > 0) {
              /// Create the assignment structure for this assignment.
                $asselement->id = $assignment->id;
                $asselement->name = $assignment->name;
                $asselement->mid = $assignment->coursemodule;
                $asselement->unsubmitted = 0;
                $asselement->resubmitted = 0;
                $asselement->unmarked = 0;
                $asselement->marked = 0;

                $ass_func = $assign_type.'_get_all_submissions';
                if ($submissions = $ass_func($assignment)) {
                    foreach ($submissions as $submission) {
                        /// If this is a user we are concerned about (group related...),
                        if (!isset($this->users[$submission->userid])) {
                            continue;
                        }

                        if (!isset($this->users[$submission->userid]->overdue)) $this->users[$submission->userid]->overdue = 0;
                        if (!isset($this->users[$submission->userid]->submitted)) $this->users[$submission->userid]->submitted = 0;
                    /// If this submission is by a user we are concerned about (group related...)
                        if (isset($this->users[$submission->userid])) {
                            if (($submission->timemodified <= 0) && ($assignment->assignmenttype != 'offline')) {
                                $unsubmitted[$submission->userid] = true;   /// for use in grades.
                            /// For the block summary, only count unsubmitted that are overdue.
                            /// Zero means no due date.
                                if (($assignment->timedue > 0) && ($assignment->timedue <= $timenow)) {
                                    $this->users[$submission->userid]->overdue++;
                                    $asselement->unsubmitted++;
                                }
                            } else if (($assign_type == 'newassignment') && ($submission->latest <= 0)) {
                                /// Skip older submission versions for 'newassignment'.
                                continue;
                        /// For this block, 'unmarked' means 'never marked'.
                            } else if ($submission->timemarked <= 0) {
                                $this->users[$submission->userid]->submitted++;
                                $asselement->unmarked++;
                            } else if ($submission->timemarked < $submission->timemodified) {
                                $this->users[$submission->userid]->submitted++;
                                $asselement->resubmitted++;
                            } else {
                                $this->users[$submission->userid]->submitted++;
                                $asselement->marked++;
                            }
                        }
                    }
                }
                $this->assignment[] = $asselement;

                if ($grades = $grade_func($assignment->id)) {
                    if (is_array($grades->grades)) {
                        foreach ($grades->grades as $userid => $grade) {
                        /// If this is a user we are concerned about (group related...),
                        /// and the grades are numerical... 
                            if (isset($this->users[$userid]) &&
                                (is_numeric($grades->maxgrade) && $grades->maxgrade != 0)) {
                                if (isset($this->users[$userid]->grades) && !isset($unsubmitted[$userid])) {
                                    $this->users[$userid]->grades =
                                        (int)(($this->users[$userid]->grades + (($grade / $grades->maxgrade) * 100)) / 2);
                                } else if (!isset($unsubmitted[$userid])) {
                                    $this->users[$userid]->grades = (int)(($grade / $grades->maxgrade) * 100);
                                }
                            }
                        }
                    }
                }
              }
            }
        } else {
            return false;
        }
    }

    function get_forum_data() {
        global $CFG;

        $timenow = time();

        if (($forums = get_all_instances_in_course('forum', $this->course)) !== false) {
            foreach ($forums as $forum) {

            /// Only concerned about teacher-marked forums.
                if ($forum->assessed == 2) {

                    require_once($CFG->dirroot.'/mod/forum/lib.php');
    
                /// Create the assignment structure for this assignment.
                    $asselement->id = $forum->id;
                    $asselement->name = $forum->name;
                    $asselement->mid = $forum->coursemodule;
                    $asselement->unsubmitted = 0;
                    $asselement->resubmitted = 0;
                    $asselement->unmarked = 0;
                    $asselement->marked = 0;
    
                    if (is_array($this->users) && ($submissions = forum_get_discussions($forum->id))) {
                        foreach ($submissions as $submission) {
                        /// If this submission is by a user we are concerned about (group related...)
                            if (isset($this->users[$submission->userid])) {
                                if (!isset($this->users[$submission->userid]->submitted)) {
                                    $this->users[$submission->userid]->submitted = 0;
                                }
                                $submitted[$submission->userid] = true;
                            /// For this block, 'unmarked' means 'never marked'.
                                if (get_field('forum_ratings', 'post', 'post', $submission->id)) {
                                    $asselement->marked++;
                                } else {
                                    $asselement->unmarked++;
                                }
                                if (!isset($this->users[$submission->userid]->submitted)) {
                                    $this->users[$submission->userid]->submitted = 1;
                                } else {
                                    $this->users[$submission->userid]->submitted++;
                                }
                            }
                        }
                        /// Calculate the unsubmitted posts.
                        foreach ($this->users as $userid => $user) {
                            if ((!isset($submitted[$userid])) || ($submitted[$userid] !== true)) {
                                $unsubmitted[$userid] = true;
                                if (($forum->assesstimefinish != 0) && ($forum->assesstimefinish <= $timenow)) {
                                    $this->users[$userid]->overdue++;
                                    $asselement->unsubmitted++;
                                }
                            }
                        }
                    }
                    $this->assignment[] = $asselement;
    
                /// Calculate the user grades...
                    if ($grades = forum_grades($forum->id)) {
                        if (is_array($grades->grades)) {
                            foreach ($grades->grades as $userid => $grade) {
                            /// If this is a user we are concerned about (group related...)
                            /// and the grades are numerical... 
                                if (isset($this->users[$userid]) &&
                                    (is_numeric($grades->maxgrade) && $grades->maxgrade != 0)) {
                                    if (isset($this->users[$userid]->grades) && !isset($unsubmitted[$userid])) {
                                        $this->users[$userid]->grades =
                                            (int)(($this->users[$userid]->grades + (($grade / $grades->maxgrade) * 100)) / 2);
                                    } else if (!isset($unsubmitted[$userid])) {
                                        $this->users[$userid]->grades = (int)(($grade / $grades->maxgrade) * 100);
                                    }
                                }
                            }
                        }
                    }
                }
            }
        } else {
            return false;
        }
    }

    function get_journal_data() {
        global $CFG;

        $timenow = time();

        if (($journals = get_all_instances_in_course('journal', $this->course)) !== false) {
            foreach ($journals as $journal) {
                require_once($CFG->dirroot.'/mod/journal/lib.php');

            /// Create the assignment structure for this assignment.
                $asselement->id = $journal->id;
                $asselement->name = $journal->name;
                $asselement->mid = $journal->coursemodule;
                $asselement->unsubmitted = 0;
                $asselement->resubmitted = 0;
                $asselement->unmarked = 0;
                $asselement->marked = 0;

                if ($submissions = get_records('journal_entries', 'journal', $journal->id)) { 
                    foreach ($submissions as $submission) {
                    /// If this submission is by a user we are concerned about (group related...)
                        if (isset($this->users[$submission->userid])) {
                        /// For this block, 'unmarked' means 'never marked'.
                            $submitted[$submission->userid] = true;
                            if ($submission->timemarked <= 0) {
                                $this->users[$submission->userid]->submitted++;
                                $asselement->unmarked++;
                            } else if ($submission->timemarked < $submission->modified) {
                                $this->users[$submission->userid]->submitted++;
                                $asselement->resubmitted++;
                            } else {
                                $this->users[$submission->userid]->submitted++;
                                $asselement->marked++;
                            }
                        }
                    }
                    /// Calculate the unsubmitted entries.
                    foreach ($this->users as $userid => $user) {
                        if ($submitted[$userid] !== true) {
                            $unsubmitted[$userid] = true;
                            if (($journal->days != 0) &&
                                ($this->course->startdate+($journal->days*(24*60*60)) <= $timenow)) {
                                $this->users[$userid]->overdue++;
                                $asselement->unsubmitted++;
                            }
                        }
                    }
                }
                $this->assignment[] = $asselement;

            /// Calculate the user grades...
                if ($grades = journal_grades($journal->id)) {
                    if (is_array($grades->grades)) {
                        foreach ($grades->grades as $userid => $grade) {
                        /// If this is a user we are concerned about (group related...)
                        /// and the grades are numerical... 
                            if (isset($this->users[$userid]) &&
                                (is_numeric($grades->maxgrade) && $grades->maxgrade != 0)) {
                                if (isset($this->users[$userid]->grades) && !isset($unsubmitted[$userid])) {
                                    $this->users[$userid]->grades =
                                        (int)(($this->users[$userid]->grades + (($grade / $grades->maxgrade) * 100)) / 2);
                                } else if (!isset($unsubmitted[$userid])) {
                                    $this->users[$userid]->grades = (int)(($grade / $grades->maxgrade) * 100);
                                }
                            }
                        }
                    }
                }
            }
        } else {
            return false;
        }
    }

    function get_lesson_data() {
        global $CFG;

        $timenow = time();

        if (($lessons = get_all_instances_in_course('lesson', $this->course)) !== false) {
            foreach ($lessons as $lesson) {
                require_once($CFG->dirroot.'/mod/lesson/lib.php');
                require_once($CFG->dirroot.'/mod/lesson/locallib.php');

            /// Create the assignment structure for this assignment.
                $asselement->id = $lesson->id;
                $asselement->name = $lesson->name;
                $asselement->mid = $lesson->coursemodule;
                $asselement->unsubmitted = 0;
                $asselement->resubmitted = 0;
                $asselement->unmarked = 0;
                $asselement->marked = 0;

                if ($essaypages = get_records_select("lesson_pages", "lessonid = $lesson->id AND qtype = ".LESSON_ESSAY)) { // get pages that are essay
                    // get only the attempts that are in response to essay questions
                    $essaypageids = implode(",", array_keys($essaypages)); // all the pageids in comma seperated list
                    if ($essayattempts = get_records_select("lesson_attempts", "lessonid = $lesson->id AND pageid IN($essaypageids)")) {
                        $studentessays = array();
                        // makes an array that organizes essayattempts by grouping userid, then pageid, then try count
                        foreach ($essayattempts as $essayattempt) {
                            $studentessays[$essayattempt->userid][$essayattempt->pageid][$essayattempt->retry][] = $essayattempt;            
                            $submitted[$essayattempt->userid][$essayattempt->pageid] = true;
                        }

                        foreach ($studentessays as $pages) {  // students
                            foreach ($pages as $tries) {  // pages
                                // go through each essay per page
                                foreach($tries as $try) {  // actual attempts
                                    // make sure they didn't answer it more than the max number of attmepts
                                    if (count($try) > $lesson->maxattempts) {
                                        $essay = $try[$lesson->maxattempts-1];
                                    } else {
                                        $essay = end($try);
                                    }
                                    $essayinfo = unserialize($essay->useranswer);
                                    if ($essayinfo->graded == 0) {
                                        $asselement->unmarked++;
                                    } else {
                                        $asselement->marked++;
                                    }
                                }
                            }
                        }
                    } else {
                    /// No essay pages, continue main loop.
                        continue;
                    }

                    /// Calculate the unsubmitted entries.
                    foreach ($this->users as $userid => $user) {
                        foreach ($essaypages as $pageid => $page) {
                            if (!isset($submitted[$userid][$pageid]) || 
                                ($submitted[$userid][$pageid] !== true)) {
                                $unsubmitted[$userid] = true;
                                if ($lesson->deadline <= $timenow) {
                                    $this->users[$userid]->overdue++;
                                    $asselement->unsubmitted++;
                                }
                            }
                        }
                    }
                }

                $this->assignment[] = $asselement;

            /// Calculate the user grades...
                if ($grades = lesson_grades($lesson->id)) {
                    if (isset($grades->grades) && is_array($grades->grades)) {
                        foreach ($grades->grades as $userid => $grade) {
                        /// If this is a user we are concerned about (group related...)
                        /// and the grades are numerical... 
                            if (isset($this->users[$userid]) &&
                                (is_numeric($grades->maxgrade) && $grades->maxgrade != 0)) {
                                if (isset($this->users[$userid]->grades) && !isset($unsubmitted[$userid])) {
                                    $this->users[$userid]->grades =
                                        (int)(($this->users[$userid]->grades + (($grade / $grades->maxgrade) * 100)) / 2);
                                } else if (!isset($unsubmitted[$userid])) {
                                    $this->users[$userid]->grades = (int)(($grade / $grades->maxgrade) * 100);
                                }
                            }
                        }
                    }
                }
            }
        } else {
            return false;
        }
    }

}

    /// Used by uasort to reorder the user array by overdue count in decreasing number.
    function sort_overdue_users($a, $b) {
        if ((empty($a->overdue) || empty($b->overdue)) || ($a->overdue == $b->overdue)) {
            return 0;
        } else {
            return ($a->overdue < $b->overdue) ? 1: -1;
        }
    }
?>
