<?php // $Id: marking.php,v 1.6.4.1 2007/05/23 16:56:38 mchurch Exp $
      // Displays all grades for a course

    require_once("../../config.php");
    require_once($CFG->dirroot.'/course/lib.php');

    $id = required_param('id', PARAM_INT);              // course id
    $download = optional_param('download', '', PARAM_ALPHA);   // to download data 
    $mid = optional_param('mid', 0, PARAM_INT);            // mod id to look at
    $muser = optional_param('muser', 0, PARAM_INT);          // user id to summarize

/// From mod grade files:
    $sort = optional_param('sort', "timemodified", PARAM_ALPHA); 
    $dir = optional_param('dir', "DESC", PARAM_ALPHA);
    $timenow = optional_param('timenow', 0, PARAM_INT);
    $action = optional_param('action', '');

    require_login();

    if (! $course = get_record("course", "id", $id)) {
        error("Course ID was incorrect");
    }

    if (!isteacher($course->id)) {
        error("Only teachers can use this page!");
    }

    $strupdate = get_string('update');
    $strview = get_string('view');

/// Array of functions to call for grading purposes for modules.
    $mod_grades_array = array(
        'assignment' => '/blocks/marking/assign.marking.html',
        'newassignment' => '/blocks/marking/newassign.marking.html',
        'journal' =>    '/blocks/marking/journal.marking.html',
        'lesson' =>    '/blocks/marking/lesson.marking.html',
        'forum' =>      '/blocks/marking/forum.marking.html'
        );

/// Array of functions to call for unsubmitted users for modules.
    $mod_uusers_array = array(
        'assignment' => 'get_unsubmitted_assignment_data',
        'newassignment' => 'get_unsubmitted_assignment_data',
        'journal' =>    'get_unsubmitted_forum_data',
        'lesson' =>     'get_unsubmitted_lesson_data',
        'forum' =>      'get_unsubmitted_journal_data'
        );

    $strgrades = get_string("grades");
    $strgrade = get_string("grade");
    $strmax = get_string("maximumshort");
    $stractivityreport = get_string("activityreport");

    $isteacheredit = isteacheredit($course->id);
    $isadmin = isadmin();

/// Kludgy hack to allow selected groups in activity marking routines to stick.
/// Use the SESSION 'fromdiscussion' property to remember which function we came from.
/// If its not this one, reset the selected group session property and set the 'fromdiscussion'
/// to this one. Leaving this function will reset the 'fromdiscussion' property.
/// If a selected group has been requested, use it and store it in the 'marking_group'
/// session property. If one hasn't been requested, but the session property is set, use it.
/// Otherwise, do whatever the defaults are.
    if ($SESSION->fromdiscussion != $ME) {
        $SESSION->fromdiscussion = $ME;
        unset($SESSION->marking_group);
    }
    if (!isset($_GET['group']) && isset($SESSION->marking_group)) {
        $_GET['group'] = $SESSION->marking_group;
    } else if (isset($_GET['group'])) {
        $SESSION->marking_group = $_GET['group'];
    }

/// Check to see if groups are being used in this course
    $groupmode = ($course->groupmode || !$course->groupmodeforce);
    if (isset($_GET['group'])) {
        $changegroup = $_GET['group'];  /// 0 or higher
    } else {
        $changegroup = -1;              /// This means no group change was specified
    }
    $currentgroup = get_and_set_current_group($course, $groupmode, $changegroup);

    if ($currentgroup && (!$isteacheredit || ($changegroup >= 0))) {
        $students = get_group_students($currentgroup, "u.lastname ASC");
    } else {
        $currentgroup = false;
        $students = get_course_students($course->id, "u.lastname ASC");
    }
    $loggedinas = "<p class=\"logininfo\">".user_login_string($course, $USER)."</p>";

/// Get a list of all students
    if (!$students && !$currentgroup) {
        print_header("$course->shortname: Gradebook", "$course->fullname", 
                     "<A HREF=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</A> 
                      -> Gradebook",
                      '','', true, '', $loggedinas);
        print_heading(get_string("nostudentsyet"));
        print_footer($course);
        exit;
    }

    $columnhtml = array();  // Accumulate column html in this array.
    $columnungraded = array(); // Accumulate column graded totals in this array.
    $totungraded = 0;

/// Collect modules data
    get_all_mods($course->id, $mods, $modnames, $modnamesplural, $modnamesused);


/// Search through all the modules, pulling out grade data
    $sections = get_all_sections($course->id); // Sort everything the same as the course
    for ($i=0; $i<=$course->numsections; $i++) {
        if (isset($sections[$i])) {   // should always be true
            $section = $sections[$i];
            if ($section->sequence) {
                $sectionmods = explode(",", $section->sequence);
                foreach ($sectionmods as $sectionmod) {
                  if (!empty($mods[$sectionmod])) {
                    $mod = $mods[$sectionmod];
                    $instance = get_record($mod->modname, "id", $mod->instance);
                    $libfile = $CFG->dirroot.'/mod/'.$mod->modname.'/lib.php';
                    if (file_exists($libfile)) {
                        require_once($libfile);
                        $gradefunction = $mod->modname."_grades";

                        if ($mod->visible &&                    // Skip hidden modules
                            function_exists($gradefunction) &&  // Skip modules without grade function
                            (($mod->modname != 'forum') || ($instance->assessed == 2)) && // Only include forums that are assessed only by teachers.
                            isset($mod_grades_array[$mod->modname])) {

                            if ($modgrades = $gradefunction($mod->instance)) {
                            /// Store the number of ungraded entries for this group.
                                $gradedarray = array_keys($students);
                                $numgraded = count($gradedarray);
                                $numstudents = count($students);
                                $ungradedfunction = $mod->modname.'_count_ungraded';
                                if (function_exists($ungradedfunction)) {
                                    $ung = $ungradedfunction($instance->id, $gradedarray, $students);
                                } else {
                                    $ung = $numstudents - $numgraded;
                                }
                                $columnungraded[] = $ung;
                                $totungraded += $ung;

                            /// Get the function for the selected mod.
                                if ($mid == $mod->id) {
                                    $selectedmod = $instance;
                                    $selectedfunction = $mod_grades_array[$mod->modname];
                                } else if (!isset($selectedmod)){
                                    $selectedmod = '';
                                    $selectedfunction = '';
                                }

                                if (!empty($modgrades->maxgrade)) {
                                    if ($mod->visible) {
                                        $maxgrade = "$strmax: $modgrades->maxgrade";
                                        $maxgradehtml = "<BR>$strmax: $modgrades->maxgrade";
                                    } else {
                                        $maxgrade = "$strmax: $modgrades->maxgrade";
                                        $maxgradehtml = "<BR><FONT class=\"dimmed_text\">$strmax: $modgrades->maxgrade</FONT>";
                                    }
                                } else {
                                    $maxgrade = "";
                                    $maxgradehtml = "";
                                }
    
                                $image = '<a href="'.$CFG->wwwroot.'/mod/'.$mod->modname.'/view.php?id='.
                                         $mod->id.'" title="'.$strview.' '.$mod->modfullname.'">'.
                                         '<img border="0" valign="absmiddle" src="'.
                                         $CFG->wwwroot.'/mod/'.$mod->modname.'/icon.gif" '.
                                         'height="16" width="16" alt="'.$mod->modfullname.'"></a>';
                                $image .= ' <a href="'.$CFG->wwwroot.'/course/mod.php?update='.$mod->id.
                                          '&sesskey='.$USER->sesskey.'" '.
                                          'title="'.$strupdate.' '.$mod->modfullname.'">'.
                                         '<img border="0" valign="absmiddle" src="'.
                                         $CFG->pixpath.'/t/edit.gif" '.
                                         'height="11" width="11" alt="'.$mod->modfullname.'"></a> ';
                                if ($mod->visible) {
                                    $columnhtml[] = '<div>'.$image.' '.
                                                 '<a href="'.$CFG->wwwroot.'/blocks/marking/marking.php?id='.
                                                 $course->id.'&mid='.$mod->id.'">'.$instance->name.'</a></div>';
                                } else {
                                    $columnhtml[] = '<div>'.$image.' '.
                                                 '<a class="dimmed" href="'.$CFG->wwwroot.'/blocks/marking/marking.php?id='.
                                                 $course->id.'&mid='.$mod->id.'">'.$instance->name.'</a></div>';
                                }
                            }
                        }
                    }
                  }
                }
            }
        }
    } // a new Moodle nesting record? ;-)


    print_header("$course->shortname: $strgrades", "$course->fullname", 
                 "<A HREF=\"$CFG->wwwroot/course/view.php?id=$course->id\">$course->shortname</A> 
                  -> $strgrades",
                  '','', true, '', $loggedinas);
    include 'marking.html';
    print_footer($course);


/// Supporting Functions:
    function assignment_count_ungraded($assignment, $graded, $students) {
        global $CFG;

        $studentlist = implode(',', $graded);
        $sql = 'SELECT asb.id,asb.userid FROM '.$CFG->prefix.'assignment ass, '.$CFG->prefix.'assignment_submissions asb '.
               'WHERE ass.id = '.$assignment.' AND asb.assignment = ass.id AND asb.userid in ('.$studentlist.') AND '.
                  '((asb.timemarked < asb.timemodified AND asb.timemodified > 0) OR '.
                   '(ass.assignmenttype = \'offline\' AND asb.timemodified = 0))';
        if ($recs = get_records_sql($sql)) {
            return count($recs);
        } else {
            return 0;
        }
    }

    function newassignment_count_ungraded($assignment, $graded, $students) {
        global $CFG;

        $studentlist = implode(',', $graded);
        $sql = 'SELECT asb.id,asb.userid FROM '.$CFG->prefix.'newassignment ass, '.$CFG->prefix.'newassignment_submissions asb '.
               'WHERE ass.id = '.$assignment.' AND asb.newassignment = ass.id AND asb.userid in ('.$studentlist.') AND '.
                  '((asb.timemarked < asb.timemodified AND asb.timemodified > 0 AND asb.latest > 0) OR '.
                   '(ass.type = 0 AND asb.timemodified = 0))';
        if ($recs = get_records_sql($sql)) {
            return count($recs);
        } else {
            return 0;
        }
    }

    function journal_count_ungraded($assignment, $graded, $students) {
        $studentlist = implode(',', $graded);
        $select = 'journal = '.$assignment.' AND userid in ('.$studentlist.') AND '.
                  'timemarked < modified AND modified > 0';
        return count_records_select('journal_entries', $select);
    }

    function lesson_count_ungraded($lesson, $graded, $students) {
        global $CFG;

        require_once($CFG->dirroot.'/mod/lesson/lib.php');
        require_once($CFG->dirroot.'/mod/lesson/locallib.php');

        $studentlist = implode(',', $graded);
        $unmarked = 0;
        $select = 'lessonid = '.$lesson.' AND qtype = '.LESSON_ESSAY;
        if ($essaypages = get_records_select('lesson_pages', $select)) { // get pages that are essay
            // get only the attempts that are in response to essay questions
            $essaypageids = implode(",", array_keys($essaypages)); // all the pageids in comma seperated list
            $select = 'lessonid = '.$lesson.' AND pageid IN ('.$essaypageids.') AND '.
                      'userid IN ('.$studentlist.')';
            if ($essayattempts = get_records_select("lesson_attempts", $select)) {
                foreach ($essayattempts as $essayattempt) {
                    $essayinfo = unserialize($essayattempt->useranswer);
                    if ($essayinfo->graded == 0) {
                        $unmarked++;
                    }
                }
            }
        }

        return $unmarked;
    }

    function forum_count_ungraded($assignment, $graded, $students) {
        global $CFG;

        $studentlist = implode(',', $graded);
        $postssql = 'SELECT COUNT(*) FROM '.$CFG->prefix.'forum_discussions fd, '.$CFG->prefix.'forum_posts fp '.
                    'WHERE fd.forum = '.$assignment.' AND fp.discussion = fd.id AND '.
                       'fp.userid in ('.$studentlist.')';
        $gradessql = 'SELECT COUNT(*) FROM '.$CFG->prefix.'forum_discussions fd, '.$CFG->prefix.'forum_posts fp, '.
                        $CFG->prefix.'forum_ratings fr '.
                     'WHERE fd.forum = '.$assignment.' AND fp.discussion = fd.id AND '.
                       'fp.userid in ('.$studentlist.') AND fr.post = fp.id';

        
        $numposts = count_records_sql($postssql);
        $numgrades = count_records_sql($gradessql);
        return (int)$numposts - (int)$numgrades;
    }

    function mb_get_average_turnaround(&$submissions, &$users) {
    
        if (!is_array($submissions) || empty($submissions)) {
            return (0);
        }
    
        $subcount = 0;
        $timetotal = 0;
        foreach ($submissions as $submission) {
            if (isset($users[$submission->userid]) && ($submission->timemarked > $submission->timemodified)) {
                $subcount++;
                $timetotal += ($submission->timemarked - $submission->timemodified);
            }
        }
    
        if (($subcount <= 0) || ($timetotal <= 0)) {
            return (0);
        } else {
            return (($timetotal / $subcount) / (60*60));
        }
    }
    
    /// TODO - Move these to a marking block lib.php file...
    
    function mb_send_all_reminders(&$data, &$users, &$course, &$cm) {
        global $CFG, $USER;
        require_once($CFG->dirroot.'/message/lib.php');
    
        if (!is_array($data->reminder)) {
            return false;
        }
    
        $idheader = '<span title="Reminder-'.$course->id.'-'.$cm->id.'-'.time().'"></span>'."\n";
    
        foreach ($data->reminder as $userid => $checked) {
            $message = $idheader;
            $args = new Object();
            $args->username = $users[$userid]->firstname;
            $args->activityname = $cm->name;
            $message .= get_string('remindermessage', 'block_marking', $args);
            message_post_message($USER, $users[$userid], $message, FORMAT_HTML, 'direct');
        }
        return true;
    }
    
    function mb_get_reminder_info($fuser, $tuser, $courseid, $cmid) {
        global $CFG;
        require_once($CFG->dirroot.'/message/lib.php');
    
        $reminfo = new Object();
        $reminfo->numrems = 0;
        $reminfo->lastrem = 0;
        if (!$messages = message_get_history($fuser, $tuser)) {
            return $reminfo;
        }
    
        $rempat = '/<span title="Reminder\-'.$courseid.'\-'.$cmid.'\-(\d+)"><\/span>/';
        foreach ($messages as $message) {
            $matches = array();
            if (preg_match($rempat, $message->message, $matches)) {
                $reminfo->numrems++;
                $reminfo->lastrem = ($matches[1] > $reminfo->lastrem) ? $matches[1] : $reminfo->lastrem; 
            }
        }
    
        return $reminfo;
    }
?>
